load "SU2.m";
load "G33.m";
load "NG33.m";
load "NG13.m";
load "Splitting.m";

R<x>:=PolynomialRing(Rationals());

procedure testLMFDB()
  R<x>:=PolynomialRing(Rationals());

  data:=[dataSU2,dataNG13,dataNG33,dataG33];
  headers:=["Sato-Tate groups with identity component SU(2)", "Sato-Tate group N(G_{1,3})", "Sato-Tate group N(G_{3,3})", "Sato-Tate group G_{3,3}"];

  counter:=0;
  for i in [3..3] do
  PrintFile("./DecomposableJacobians.out", headers[i]);

  for r in data[i] do
	counter:=counter+1;
	"Trying curve number", counter;
	try 
	PrintFile("./DecomposableJacobians.out", "===============");
	PrintFile("./DecomposableJacobians.out", HyperellipticCurve(R!r[1],R!r[2]));
	res:=ComputeMap2(R!r[1],R!r[2]) ;
	if res eq false then
		PrintFile("./DecomposableJacobians.out", "ERROR");
		PrintFile("./Errors.out", [R!r[1],R!r[2]]);
	end if;
	catch e
		PrintFile("./DecomposableJacobians.out", "ERROR");
		PrintFile("./Errors.out", [R!r[1],R!r[2]]);
	end try;
  end for;
  PrintFile("./DecomposableJacobians.out", "\n\n\n");
  end for;
end procedure;