'''
Compute the characteristic polynomial of Frobenius for the curve y^2=f(x) at the prime p.
It assumes that p is odd and the curve has good reduction at p
'''

def Frobenius_Polynomial(p,a0,a1,a2,a3,a4,a5=1,a6=0,slow=false) :
    R.<t> = PolynomialRing(GF(p))
    H=HyperellipticCurve(a6*t^6+a5*t^5+a4*t^4+a3*t^3+a2*t^2+a1*t+a0)
    if (a6 == 0 and slow==false) :
      return H.frobenius_polynomial()
    else :
      pCount=H.count_points_exhaustive(n=2)
      a=pCount[0]
      b=pCount[1]
      s1=p+1-a;
      s2=1/2*(a^2+2*p-2*a-2*a*p+b)
      poly=ZZ['x']([p^2,-p*s1,s2,-s1,1])
      return poly
